


function utilityAwaitDOMUpdate(callback) {
    //let ranTime = performance.now()
    //console.log("Called:",ranTime);
    requestAnimationFrame(() =>
        requestAnimationFrame(function () {
            //console.log("Ran:",(performance.now()-ranTime),"mS");
            callback();
        }));
}

//already had isArrayEqual()
function utilityCheckArraysAreEquals(a, b) {
    return Array.isArray(a) &&
        Array.isArray(b) &&
        a.length === b.length &&
        a.every((val, index) => val === b[index]);
}


function utilityObjectMerge(current, updates) {
    console.log(" utilityObjectMerge()", current, updates)

    for (let i = 0; i < Object.keys(updates).length; i++) {
        let key = Object.keys(updates)[i];
        //console.log("MERGE", key)
        if (!current.hasOwnProperty(key) || typeof updates[key] !== "object") current[key] = updates[key];
        else utilityObjectMerge(current[key], updates[key]);
    }
    return current;
}


//==================================================================================================================


window.addEventListener('message', function (event) {
    console.log("Message received from the child: " + event.data); // Message received from child
    //add confirm menu about overwriting
    //load message into mainObj.layout.patchCoords ?
    mainObj.layout.patchCoords = [];
    let mapObj = JSON.parse(event.data);
    console.log(mapObj);
    for (const i in mapObj) {
        mainObj.layout.patchCoords.push(((mapObj[i].x + 1) + "," + (mapObj[i].y + 1)).trim());
    }
    console.log(mainObj.layout.patchCoords)

    mainObj.layout.iconAmount = mainObj.layout.patchCoords.length; //set to the defined amount, not specified amount
    uxToolsLayoutUpdate(); //update iconAmount box
    layoutGraphicIconReset(); //reset first
    layoutGraphicBuildIcons(); //now X-Y are intialized and populated, build the positions
});



//==================================================================================================================

document.addEventListener('click', function (e) {
    //var x = event.clientX;     // Get the horizontal coordinate
    //var y = event.clientY;     // Get the vertical coordinate
    //console.log("left clicked    X: " + x + "   Y: " + y);
    //--------------------------- runs after button's click event, so closes it right away ------------------------------
    if (stateUX.messageLogIsOpen) {
        //console.log("HAPPENED " + stateUX.messageLogIsOpen); //DEBUG
        uxToggleMessageLog(e);
        //can't run this first apparently.... so whatever
    }
});

document.getElementById("status-bar-openicon").addEventListener('click', function (e) { uxToggleMessageLog(e) });
document.getElementById("navtab-sequence-menu").addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-1') });
document.getElementById("status-bar-badge").addEventListener('click', function () { commSerialAutoScan() });
//-------------------------------------------------------------------
document.getElementById("toolmenu-sequences-icon").addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-6') });
document.getElementById("toolmenu-sequences-help").addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-sequencehelp') });
document.getElementById("toolmenu-sequences-name").addEventListener('change', function () { seqEditName(this) });
document.getElementById("toolmenu-sequences-mode").addEventListener('change', function () { seqEditMode(this) });
document.getElementById("toolmenu-sequences-import").addEventListener('click', function () { sequenceImportData() });
document.getElementById("toolmenu-sequences-imgwiz").addEventListener('click', function () {
    overlayMenuEvent(null, 'open', 'menu-importwizard');
    // document.getElementById("ovmenu-importwizard-mode").selectedIndex = 0;
    // document.getElementById("ovmenu-importwizard-startpos").selectedIndex = 0;
    uxMenuImageWizardUpdate();
});
document.getElementById("ovmenu-importwizard-mode").addEventListener('change', uxMenuImageWizardUpdate);


document.getElementById("toolmenu-sequences-speed").addEventListener('change', function () { seqEditSpeed(this) });
document.getElementById("toolmenu-sequences-numpix").addEventListener('change', function () { seqEditNumOfPixels(this) });
document.getElementById("toolmenu-sequences-transition").addEventListener('change', function () { seqEditTransition(this) });
document.getElementById("toolmenu-sequences-playmode").addEventListener('change', function () { seqEditPlayMode(this) });
document.getElementById("toolmenu-sequences-colormode").addEventListener('change', function () { selectConfirmBox('change-seq-colormode', () => { seqEditColorMode(1) }, function () { seqEditColorMode(0) }) });
document.getElementById("toolmenu-sequences-intensity").addEventListener('change', function () { seqEditSeqIntensity(this) });
document.getElementById("toolmenu-sequences-clone").addEventListener('change', function () { seqEditPacketClone(this) });
document.getElementById("toolmenu-sequences-intensity").addEventListener('change', function () { seqEditSeqIntensity(this) });
document.getElementById("toolmenu-sequences-clone").addEventListener('change', function () { seqEditPacketClone(this) });
//-------------------------------------------------------------------

document.getElementById('prompt-pixelmapperclose-applyclose').addEventListener('click', function (e) { document.getElementById("ovmenu-pixelmapper-iframe").contentWindow.postMessage("POSTTOAURORA", "*"); overlayPromptEvent(e, 'close', 'prompt-pixelmapperclose'); stateUX.targetMenu = null; overlayMenuEvent(e, "close"); });
document.getElementById('prompt-pixelmapperclose-cancelclose').addEventListener('click', function (e) { overlayPromptEvent(e, 'close', 'prompt-pixelmapperclose'); stateUX.targetMenu = null; overlayMenuEvent(e, "close"); });
document.getElementById('prompt-pixelmapperclose-cancel').addEventListener('click', function (e) { overlayPromptEvent(e, 'close', 'prompt-pixelmapperclose'); });


document.getElementById('toolmenu-ledicon-createmap').addEventListener('click', function () { overlayMenuEvent(null, 'open', 'menu-pixelmapper'); });
document.getElementById('ws-software-pixelmap').addEventListener('click', function () { overlayMenuEvent(null, 'open', 'menu-pixelmapper'); });
document.getElementById('toolmenu-effects-resetstartvals').addEventListener('click', function () { selectConfirmBox('reset-startvals', function () { toolResetStartValues(SelSeq); }) });
document.getElementById('toolmenu-effects-generaterun').addEventListener('click', function () { selectConfirmBox('generate-startvals', function () { toolGenerateStartVals(SelSeq); }) });
document.getElementById('toolmenu-paint-col1').addEventListener('click', function () { toolSelectPaintColor(1) });
document.getElementById('toolmenu-paint-col2').addEventListener('click', function () { toolSelectPaintColor(2) });
document.getElementById('toolmenu-paint-funcmodeapply').addEventListener('click', function () { toolFuncPaintApply() });
document.getElementById('toolmenu-ledicon-reset').addEventListener('click', function () { layoutGraphicResetPosition() });
document.getElementById('toolmenu-ledicon-loadfile').addEventListener('click', function () { fileLoadLayoutMap() });
document.getElementById('toolmenu-ledicon-addlayout').addEventListener('click', function () { layoutAdvancedAdd() });
document.getElementById('toolmenu-ledicon-resetlayout').addEventListener('click', function () { selectConfirmBox('reset-layouticons', function () { layoutGraphicIconReset() }) });
document.getElementById('toolmenu-zones-clear').addEventListener('click', function () { layoutZoneClear() });
document.getElementById('toolmenu-zones-merge').addEventListener('click', function () { layoutZoneMerge() });
document.getElementById('toolmenu-graphicimage-load').addEventListener('click', function () { fileLoadGraphicLayoutImage() });
document.getElementById('toolmenu-graphicimage-reset').addEventListener('click', function () { layoutImageReset() });
document.getElementById('toolmenu-playback-play').addEventListener('click', function () { toolPlaybackPreview('play') });
document.getElementById('toolmenu-playback-stop').addEventListener('click', function () { toolPlaybackPreview('stop') });
document.getElementById('toolmenu-playback-uploadhwpv').addEventListener('click', function () { commUploadHWPV(stateSeq.index) });
document.getElementById('toolmenu-frame-copy').addEventListener('click', function () { toolsCopyFrame() });
document.getElementById('toolmenu-frame-paste').addEventListener('click', function () { toolsPasteFrame() });
document.getElementById('ws-connection-livemenu').addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-2') });
document.getElementById('ws-connection-standmenu').addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-3') });
document.getElementById('ws-connection-gammamenu').addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-4') });
// document.getElementById('ws-connection-setupconn').addEventListener('click', function () { uxTriggerElementClick('navtab-hardware') });
// document.getElementById('ws-connection-setupconfigs').addEventListener('click', function () { uxTriggerElementClick('navtab-hardware') });
document.getElementById('ws-connection-downloadsequences').addEventListener('click', function () { selectConfirmBox('download-sequences', function () { commDownloadSequences() }) });
document.getElementById('ws-connection-fullupload').addEventListener('click', function () { selectConfirmBox('upload-sequences', function () { commFullSeqUpload() }) });
document.getElementById('ws-connection-resetindex').addEventListener('click', function () { selectConfirmBox('reset-index', function () { indexReset() }) });
document.getElementById('ws-software-webpage').addEventListener('click', function () { selectConfirmBox('visit-aurora-webpage', function () { uxVisitWebpageAurora() }) });
document.getElementById('ws-software-eula').addEventListener('click', function () { selectConfirmBox('open-eula', function () { uxOpenEULA() }) });
document.getElementById('ws-software-resetwindow').addEventListener('click', function () { selectConfirmBox('reset-windowsize', function () { uxResetWindowSize() }) });
document.getElementById('ws-software-manual').addEventListener('click', function () { selectConfirmBox('open-manual', function () { uxOpenManual() }) });
document.getElementById('ws-software-supportpage').addEventListener('click', function () { selectConfirmBox('open-supportpage', function () { uxOpenContactPage() }) });
document.getElementById('ws-software-videotut').addEventListener('click', function () { selectConfirmBox('open-tutvids', function () { uxOpenVideoTutorials() }) });
document.getElementById('ws-software-loadrecent').addEventListener('click', function () { selectConfirmBox('load-targetsave', function () { fileLoadPreviousSequenceFile() }) });
document.getElementById('ws-software-loadsequences').addEventListener('click', function () { fileLoadSequenceFile() });
document.getElementById('ws-software-savesequences').addEventListener('click', function () { systemSaveSequenceFile() });
document.getElementById('ws-software-savesequencesas').addEventListener('click', function () { fileSaveAsSequenceFile() });
document.getElementById('ws-software-loadsinglesequence').addEventListener('click', function () { });
document.getElementById('ws-software-sequencesreset').addEventListener('click', function () { selectConfirmBox('reset-sequences', function () { sequencesReset() }) });
document.getElementById('ws-software-simdevice').addEventListener('click', function (e) { uxModalDeviceProfiles(e)});
document.getElementById('ws-software-demonstration').addEventListener('click', function () { selectConfirmBox('software-demo', function () { uxLoadSoftwareDemo() }) });
document.getElementById('ws-hardware-autoconnect').addEventListener('click', function () { commSerialAutoScan() });
document.getElementById('ws-hardware-disconnect').addEventListener('click', function () { commDisconnectFromPort() });
document.getElementById('ws-hardware-connect').addEventListener('click', function () { commSerialPortConnect() });
document.getElementById('ws-hardware-tcpconnect').addEventListener('click', function () { networkOpenTCP() });
document.getElementById('ws-hardware-devwebpage').addEventListener('click', function () { selectConfirmBox('visit-device-webpage', function () { uxVisitWebpageDevice() }) });
document.getElementById('ws-hardware-devupdatewebpage').addEventListener('click', function () { selectConfirmBox('visit-updates-webpage', function () { uxVisitWebpageUpdates() }) });
document.getElementById('ws-hardware-bootmode').addEventListener('click', function () { selectConfirmBox('enter-bootloader', function () { auroraCMD.setBootloaderMode() }) });
document.getElementById('ws-hardware-senduserid').addEventListener('click', function () { selectConfirmBox('set-userid', function () { commSetUserIDValue() }) });
document.getElementById('ws-hardware-upconfigs').addEventListener('click', function () { selectConfirmBox('upload-configs', function () { commUploadConfigs() }) });
document.getElementById('ws-hardware-downconfigs').addEventListener('click', function () { selectConfirmBox('download-configs', function () { commDownloadConfigs() }) });
document.getElementById('ws-pov-seqmodecont-button1').addEventListener('click', function () { uxPOVDirectionMode(this) });
document.getElementById('ws-pov-seqmodecont-button2').addEventListener('click', function () { uxPOVDirectionMode(this) });
document.getElementById('ws-pov-seqmodecont-button3').addEventListener('click', function () { uxPOVDirectionMode(this) });
document.getElementById('ws-pov-seqmodecont-button4').addEventListener('click', function () { uxPOVDirectionMode(this) });
document.getElementById('overlay-menu-close-button').addEventListener('click', function (e) { overlayMenuEvent(e, 'close') });
document.getElementById('ovmenu-sequence-listing-addbutton').addEventListener('click', function () { sequenceCreateNew() });
document.getElementById('ovmenu-2-resetcolors').addEventListener('click', function () { ovmLiveControlReset() });
document.getElementById('ovmenu-2-copycolor').addEventListener('click', function () { });
document.getElementById('ovmenu-3-con-speeddown').addEventListener('click', function () { standaloneMenuCmd('speedDown') });
document.getElementById('ovmenu-3-con-speedup').addEventListener('click', function () { standaloneMenuCmd('speedUp') });
document.getElementById('ovmenu-3-con-speedset').addEventListener('click', function () { standaloneMenuCmd('speedSet') });
document.getElementById('ovmenu-3-con-intens-send').addEventListener('click', function () { standaloneMenuCmd('intenSet') });
document.getElementById('ovmenu-3-con-stepfwd').addEventListener('click', function () { standaloneMenuCmd('stepNext') });
document.getElementById('ovmenu-3-con-stpback').addEventListener('click', function () { standaloneMenuCmd('stepPrev') });
document.getElementById('ovmenu-3-con-frameselectsend').addEventListener('click', function () { standaloneMenuCmd('frameSet') });

document.getElementById('ovmenu-3-con-seqidsend').addEventListener('click', function () { standaloneMenuCmd('seqSetForm') });
document.getElementById('ovmenu-3-con-prevseq').addEventListener('click', function () { standaloneMenuCmd('seqPrev') });
document.getElementById('ovmenu-3-con-playpause').addEventListener('click', function () { standaloneMenuCmd('playPause') });
document.getElementById('ovmenu-3-con-nextseq').addEventListener('click', function () { standaloneMenuCmd('seqNext') });
document.getElementById('ovmenu-3-con-fadecyclesend').addEventListener('click', function () { standaloneMenuCmd('fadeConSend') });
document.getElementById('ovmenu-4-con-download').addEventListener('click', function () { commDownloadGammaTable() });
document.getElementById('ovmenu-4-con-upload').addEventListener('click', function () { selectConfirmBox('upload-gamma', function () { commUploadGammaTable() }) });
document.getElementById('colorpicker-apply').addEventListener('click', function () { colorPicker.apply() });
document.getElementById('colorpicker-cancel').addEventListener('click', function () { colorPicker.close() });
document.getElementById('overlay-confirmbox-yes').addEventListener('click', function () { });
document.getElementById('overlay-confirmbox-no').addEventListener('click', function () { });
document.getElementById('progressbar-cancel').addEventListener('click', function () { userCancelProgress() });

//-------------------------------------------------------------------

document.getElementById('ws-connection-hwpvtile').addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'hwpv') });
document.getElementById('ws-connection-idleseqtile').addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'idle') });
document.getElementById('frame-add-button').addEventListener('click', function () { selectAddFrame() });
document.getElementById('frame-subtract-button').addEventListener('click', function () { selectSubtractFrame() });
document.getElementById('standalone-remote-onoff').addEventListener('click', function () { standaloneMenuCmd('onOff') });
document.getElementById('standalone-remote-prev').addEventListener('click', function () { standaloneMenuCmd('seqPrev') });
document.getElementById('standalone-remote-playpause').addEventListener('click', function () { standaloneMenuCmd('playPause') });
document.getElementById('standalone-remote-next').addEventListener('click', function () { standaloneMenuCmd('seqNext') });
document.getElementById('standalone-remote-selred').addEventListener('click', function () { standaloneMenuCmd('colorR') });
document.getElementById('standalone-remote-selgreen').addEventListener('click', function () { standaloneMenuCmd('colorG') });
document.getElementById('standalone-remote-selblue').addEventListener('click', function () { standaloneMenuCmd('colorB') });
document.getElementById('standalone-remote-selwht').addEventListener('click', function () { standaloneMenuCmd('colorW') });
document.getElementById('standalone-remote-intenup').addEventListener('click', function () { standaloneMenuCmd('intensityUp') });
document.getElementById('standalone-remote-spdup').addEventListener('click', function () { standaloneMenuCmd('speedUp') });
document.getElementById('standalone-remote-seq').addEventListener('click', function () { standaloneMenuCmd('seq') });
document.getElementById('standalone-remote-colset').addEventListener('click', function () { standaloneMenuCmd('colorSet') });
document.getElementById('standalone-remote-intendwn').addEventListener('click', function () { standaloneMenuCmd('intensityDown') });
document.getElementById('standalone-remote-spddwn').addEventListener('click', function () { standaloneMenuCmd('speedDown') });
document.getElementById('standalone-remote-idle').addEventListener('click', function () { standaloneMenuCmd('setIdle') });
document.getElementById('standalone-remote-colreset').addEventListener('click', function () { standaloneMenuCmd('colorReset') });
document.getElementById('standalone-remote-seq1').addEventListener('click', function () { standaloneMenuCmd('seqSet', 1) });
document.getElementById('standalone-remote-seq2').addEventListener('click', function () { standaloneMenuCmd('seqSet', 2) });
document.getElementById('standalone-remote-seq3').addEventListener('click', function () { standaloneMenuCmd('seqSet', 3) });
document.getElementById('standalone-remote-seq4').addEventListener('click', function () { standaloneMenuCmd('seqSet', 4) });
document.getElementById('standalone-remote-seq5').addEventListener('click', function () { standaloneMenuCmd('seqSet', 5) });
document.getElementById('standalone-remote-seq6').addEventListener('click', function () { standaloneMenuCmd('seqSet', 6) });
document.getElementById('standalone-remote-seq7').addEventListener('click', function () { standaloneMenuCmd('seqSet', 7) });
document.getElementById('standalone-remote-seq8').addEventListener('click', function () { standaloneMenuCmd('seqSet', 8) });
document.getElementById('ovmenu-importwizard-fileselect').addEventListener('click', function () { fileImportImage('seqWizard'); });
document.getElementById('ovmenu-importwizard-cancel').addEventListener('click', function (e) { overlayMenuEvent(e, 'close') });


document.getElementById('ovmenu-importwizard-apply').addEventListener('click', function (e) {
    let modeDD = document.getElementById("ovmenu-importwizard-mode");
    let startDD = document.getElementById("ovmenu-importwizard-startpos");
    let actionDD = document.getElementById("ovmenu-importwizard-action");

    let action = 'none'
    let mode;
    console.log(modeDD.options[modeDD.selectedIndex].value)
    if (modeDD.options[modeDD.selectedIndex].value == 'moderowstob') {
        if (startDD.options[startDD.selectedIndex].value == 'left') {
            mode = 0;
        }
        else { //right
            mode = 3;
        }
    }
    else if (modeDD.options[modeDD.selectedIndex].value == 'moderowsbtot') {
        if (startDD.options[startDD.selectedIndex].value == 'left') {
            mode = 4;
        }
        else { //right
            mode = 5;
        }
    }
    else if (modeDD.options[modeDD.selectedIndex].value == 'modecolltor') {
        if (startDD.options[startDD.selectedIndex].value == 'top') {
            mode = 1;
        }
        else { //bottom
            mode = 2;
        }
    }
    else if (modeDD.options[modeDD.selectedIndex].value == 'modecolrtol') {
        if (startDD.options[startDD.selectedIndex].value == 'top') {
            mode = 6;
        }
        else { //bottom
            mode = 7;
        }
    }
    else if (modeDD.options[modeDD.selectedIndex].value == 'mode2d') {
        mode = 10;
        action = actionDD.options[actionDD.selectedIndex].value;
    }
    // <option value="mode2d" data-tiptext="Load a data file for the sequence mode.">2D/Static</option>
    // <option value="moderowstob">Rows, Top to Bottom</option>
    // <option value="moderowsbtot">Rows, Bottom to Top</option>
    // <option value="modecolltor">Columns, Left to Right</option>
    // <option value="modecolrtol">Columns, Right to Left</option>
    // 0: "First pixel is top left. Rows are displayed top to bottom." - width is numPixels, height is frames
    // 1: "First pixel is top left. Columns are displayed left to right." - width is frames, height is numPixels
    // 2: "First pixel is the bottom left. Columns are displayed left to right" - width is frames, height is numPixels		
    // 3: "First pixel is top right. Rows are displayed top to bottom."

    //4: "First pixel is bottom left. Rows are displayed bottom to top"
    //5: "First pixel is bottom right. Rows are displayed bottom to top"
    //6: "First pixel is top right. Columns are displayed right to left"
    //7: "First pixel is bottom right. Columns are displayed right to left"



    sequenceLoadImageAsData(stateSeq.filePath, mode,action);
    overlayMenuEvent(e, 'close', 'menu-importwizard');
});

//-------------------------------------------------------------------

document.getElementById('toolmenu-ledicon-rotation').addEventListener('input', function () { layoutGraphicRotation() });
document.getElementById('ovmenu-3-con-intenslider').addEventListener('input', function () { standaloneMenuIntensitySlide(this) });
document.getElementById('ovmenu-3-con-fadecycleslider').addEventListener('input', function () { standaloneMenuFadeControlSlide(this) });
document.getElementById('colorpicker-redslider').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-redbox').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-greenslider').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-greenbox').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-blueslider').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-bluebox').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-whiteslider').addEventListener('input', function () { colorPicker.entryUpdate(this) });
document.getElementById('colorpicker-whitebox').addEventListener('input', function () { colorPicker.entryUpdate(this) });

//-------------------------------------------------------------------

document.getElementById('frame-input').addEventListener('change', function () { selectSeqFrame(Number(this.value) - 1, false); });
document.getElementById('toolmenu-sequences-intensity').addEventListener('change', function () { seqEditSeqIntensity(this) });
document.getElementById('toolmenu-sequences-clone').addEventListener('change', function () { seqEditPacketClone(this) });
document.getElementById('toolmenu-effects-gensteps').addEventListener('change', function () { seqEditGradientSteps(this) });
document.getElementById('toolmenu-effects-graphgenenableval').addEventListener('change', function () { toolGenerateCheckbox() });
document.getElementById('toolmenu-paint-brushenableval').addEventListener('change', function () { toolPaintManualCheckbox() });
document.getElementById('toolmenu-ledicon-iconshapeval').addEventListener('change', function () { layoutEditIconShape(this) });
document.getElementById('toolmenu-ledicon-layoutshape').addEventListener('change', function () { layoutEditShape(this) });
document.getElementById('toolmenu-ledicon-dirval').addEventListener('change', function () { layoutEditDirection(this) });
document.getElementById('toolmenu-ledicon-numofpixels').addEventListener('change', function () { layoutNumberOfIcons(this) });
document.getElementById('toolmenu-ledicon-iconsize').addEventListener('change', function () { layoutEditIconSize(this) });
document.getElementById('toolmenu-ledicon-icondensity').addEventListener('change', function () { layoutEditiconDensity(this) });
document.getElementById('toolmenu-ledicon-advancedval').addEventListener('change', function () { layoutEnableAdvanced(this) });
document.getElementById('toolmenu-ledicon-advnumofpixels').addEventListener('change', function () { layoutNumberOfAdvancedIcons(this) });
document.getElementById('toolmenu-ledicon-advplace').addEventListener('change', function () { layoutAdvancedPreviewCheckBox() });
document.getElementById('toolmenu-ledicon-manplace').addEventListener('change', function () { layoutManualPlacementCheckBox(this) });
document.getElementById('toolmenu-zones-enableassignval').addEventListener('change', function () { layoutZoneAssignment() });
document.getElementById('toolmenu-graphicimage-enable').addEventListener('change', function () { layoutEnableGraphicImage(this) });
document.getElementById('toolmenu-graphicimage-positioning').addEventListener('change', function () { layoutImagePosition(); });
document.getElementById('toolmenu-graphic-grid').addEventListener('change', function () { uxCheckBoxHandler(this); });
document.getElementById('toolmenu-playback-autohwpvval').addEventListener('change', function () { uxAutoHWPVSwitch() });
document.getElementById('ws-connection-enableintensityval').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-connection-intensity').addEventListener('change', function () { uxGlobalIntensityVal(this) });
document.getElementById('ws-software-disabletips-box').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-software-language').addEventListener('change', function () { uxChangeLanguage(this) });
document.getElementById('ws-software-lowperformance-box').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-software-autoconnect-box').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-software-autoconfigdownload-box').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-software-autoload-box').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-pov-seqmodecont-usage-enable').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ws-pov-seqmodecont-usage-value').addEventListener('change', function () { uxPovGridSpeed(this) });
document.getElementById('ws-pov-seqmodecont-vidimage').addEventListener('change', function () { });
document.getElementById('ovmenu-2-viewmode').addEventListener('change', function () { ovmLiveControlUpdate(true) });
document.getElementById('ovmenu-2-numofpix').addEventListener('change', function () { ovmLiveControlUpdate(true) });
document.getElementById('ovmenu-2-bitwidth-input').addEventListener('change', function () { ovmLiveControlUpdate(true) });
document.getElementById('ovmenu-3-con-intenslider-val').addEventListener('change', function () { standaloneMenuIntensityBox(this) });
document.getElementById('ovmenu-3-con-enableseqpause').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ovmenu-3-con-frameselectpause').addEventListener('change', function () { uxCheckBoxHandler(this) });
document.getElementById('ovmenu-6-textbox').addEventListener('change', function () { seqEditDescription(this) });
document.getElementById('colorpicker-hexvalue').addEventListener('change', function () { colorPicker.updateHex(this.value) });

//-------------------------------------------------------------------

// function convertListener() {

//     var allElements = document.getElementsByTagName('input');
//     var str = [];

//     console.log("convertListener() length: ", allElements.length)
//     for (var i = 0; i < allElements.length; i++) {
//         if (typeof allElements[i].oninput === 'function') {
//             // do something with the element here
//             //    console.log( allElements[i].getAttributeNode('onclick').value );
//             str.push("document.getElementById('" + allElements[i].id + "').addEventListener('click', function(e) {" + allElements[i].getAttributeNode('onclick').value + "});\n")
//         }
//     }

//     //console.log(str)
//     fs.writeFile(path.join(process.cwd(), "gen.txt"), str, function (e) { console.log("THIS CALLBACK") });
// }


/*
function convertListener() {

    var allElements = document.getElementsByTagName('*');
    var str = [];

    console.log("convertListener() length: ", allElements.length)
    for (var i = 0; i < allElements.length; i++) {
        try {
        if (allElements[i].getAttributeNode('onchange').value != null) {
            // do something with the element here
   
            str.push("document.getElementById('" + allElements[i].id + "').addEventListener('change', function() {" + allElements[i].getAttributeNode('onchange').value + "});\n")
        }
    }
    catch(e){
        console.log("NOT THERE")
    }
    }

    //console.log(str)
    fs.writeFile(path.join(process.cwd(), "gen.txt"), str, function (e) { console.log("THIS CALLBACK") });
}
*/



